from netgen.occ import *

geo = OCCGeometry('C:/00_Temp/netgen testing/dome.step') #import step file

for x in range(2,8):  #iterate through surfaces of cuboid
    geo.SetFaceMeshsize(x,25)  #set mesh size for cuboid surfaces

geo.SetFaceMeshsize(0,100)  #set mesh size for air boundary    
geo.SetFaceMeshsize(1,25)  #set mesh size for ground plane
ngmesh = geo.GenerateMesh(maxh = 100,grading = 0.75)  #mesh the volume with prescribed size and grading


ngmesh.SetBCName(0,'air')
ngmesh.SetBCName(1,'ground')

for x in range(2,8):
    ngmesh.SetBCName(x,'voltage')
    
ngmesh.Save('C:/00_Temp/netgen testing/dome.vol') #save mesh out

from ngsolve import *
mesh = Mesh(ngmesh)
Draw(mesh)
print("materials  = ", mesh.GetMaterials())
print("boundaries = ", mesh.GetBoundaries())

gf = GridFunction(H1(mesh,order=1))
for bc in mesh.GetBoundaries():
    print("Boundary ", bc)
    gf.Set(1, definedon=mesh.Boundaries(bc))
    Draw(gf, mesh, "bc")
    input("press enter for next boundary")
           
